function COMPARE(funSet,fun,FE_max,nRun,D)
%{
funSet = 	1 real-world CEC 2011 benchmark
			    2	CEC 2005 benchmark
			    3 MyFunctions benchmark
%}
%{
 Option sets. See subswarm.m and initRand.m
 Each row: active, dicho, dichDist, dichOption, randOption
 dicho=0 => SPSO 2007
         active dicho dichDist  dichOption  randOption
%}
options0=[ 1        0      -1         -1          -1;
          1        1       0          1           2;
          1        1       0          0           2;
          1         1       1         1           2
  ];

options=[ 
          1        1       1         2          1;
  ];

% SPSO 2007
otions=[ 
          1        0       1         2          1;
  ];


%{
    For signature, 
  COMPARE(3,-1,1000,10,2)
%}
  global keepAll
  keepAll=fun==-1;
  global last

%--------------------------------------------------------------------------
results=createResults('COMPARE'); % Creates the directory for results,
%                                 with date and time
fprintf('\n Results will be saved in %s',results);
fileName = [results,'[',num2str(fun),']'];
fid = fopen(fileName, 'w');
% -------------------------------------------------------------------------
[optNb,optSet]= size(options);

%--------------------------------------------------------------------------
if ~exist('D') D=0; end
global opt_f % Just for compatibility with CEC 2005
[FuncAddr,LB,UB,D,quantis,err,opt_f]=problemsMonte(funSet,fun,D);
disp(FuncAddr)
fprintf('\n Dimension %i',D)

fprintf(fid,'Options funSet  fun  D runs FEmax Mean  Min  std.dev \n');

% Run for the different option sets
nbTest=0;
for opt=1:optNb
  if options(opt,1)==1
    nbTest=nbTest+1;
    dicho=options(opt,2);
    dichDist=options(opt,3);
    dichOption=options(opt,4);
    randOption=options(opt,5);
    last=false;
    [best_x,best_f] =dichoPSO(FuncAddr,fun, quantis,D, LB, UB, FE_max,nRun,...
      dicho, dichDist, dichOption,randOption);
    
    [bestf,ind]=min(best_f); % Min over the runs
    bestx=best_x(ind(1),:);
    meanBest=mean(best_f);
    stdBest=std(best_f);    
    
    fprintf('\n Mean          Min         Std.dev');
    fprintf('\n %e %e %e', meanBest, bestf,stdBest);
    fprintf('\n On: \n'); disp(bestx);
    last=true;
      fit=FuncAddr(bestx,fun, opt_f); 
      fprintf('\n fit %e', fit);

    fprintf('\n ---------------------')
    fprintf(fid,'[%i,%i,%i,%i] %i %i %i %i %i %e %e %e\n',...
      dicho, dichDist,dichOption,randOption, ...
      funSet, fun,D,nRun, FE_max, meanBest,bestf,stdBest);
      
    
    curve(nbTest,1:nRun)=best_f;
  end % if options(opt,1)==1
  
  % CDFs
  for t=1:nbTest
    %%%%%  TO COMPLETE
  end
end %for opt=1:optNb
fprintf('\n')
fclose('all');
end