function f= Chebyshev( x)  % Storn's Tchebychev - a 2nd ICEO function - generalized version
%{ 
	Valid for any D>2
	constraints: unconstrained
	type: multi-modal with one global minimum; non-separable
	initial upper bound = 2^D, initial lower bound = -D^n
	value-to-reach = f(x*)+1.0e-8
	f(x)=0.0;
 D=9 =>  x=[128,0,-256,0,160,0,-32,0,1];
 D=17 => 
	x=[32768,0,-131072,0,212992,0,-180224,0,84480,0,-21504,0,2688,0,-128,0,1];
	%}

  f=0; D=length(x);
  b=1.2;
  d=72.661;  % For D=9
  % d= 10558.145 % For D=17
  m=32*D;
  
  u=0;
  for j=1:D
    u=u+x(j)*(b^(D-j));  
  end
  
  if u<d
    p1=(u-d)^2;
  else
    p1=0;  
  end
  %-----
   v=0;
  for j=1:D
    v=v+x(j)*((-b)^(D-j));  
  end
  
   if v<d
    p2=(v-d)^2;
  else
    p2=0;  
  end
  
  %-----
  p3=0;
  
  for k=0:m
    wk=0;
    for j=1:D
      wk=wk+x(j)*((2*k/m -1)^(D-j));    
    end
    if wk>1
     pk=(wk-1)^2;

    else
     if wk<-1  % ?
      pk=(wk+1)^2;
     else
      pk=0;
     end  
    end
  
    p3=p3+pk;  
  end % for k
  %fprintf('\n p1 %e \n p2 %e \n p3 %e \n f %e',p1,p2,p3,f)
  f=p1+p2+p3+1;
end
