%========================================================================= fEval
function [fx,FEs]=fEval(xNorm, fun, opt_f,FuncAddr,FEs, LB, UB,quantis)
global keepAll
global xTot % TEST, signature
global fTot  % TEST, entropy
global savePos
global signature
global TSP
global bench

if ~isempty(quantis)
    xNorm=quantify(xNorm,quantis);
end
xNorm=min(max(xNorm,0),1); % In case searchSpaceExpand is >0
%  the position may be outside the definition space.
% Therefore we evaluate just a near one.


p=size(xNorm);
if p(2)==1
    xN=xNorm';
else
    xN=xNorm;
end

x=LB+(UB-LB).*xN;

switch bench
    case 1
        fx=TSPeval(x);
        FEs=FEs+1;
        
    case 4
        fx= cec13_funcLinux(x',fun); % Generated by mex 
        FEs=FEs+1;
        
    case 5
         fx=cec19_funcLinux(x',fun); % Generated by mex 
        FEs=FEs+1;
    otherwise
        
        fx = FuncAddr(x, fun, opt_f);
        FEs=FEs+1;
        
        % Unfortunately, there are  sometimes bugs in function evaluations
        % and the position can not be evaluated
        %  (see for example CEC 2011 competition, functions 5 and 6)
        if isnan(fx)
            fx=10^10; % Inf can not be used, for fmincon does not accept it
        else
            FEs=FEs+1;
        end
end

if exist('savePost')   % Just for tests
    if savePos
        xTot=[xTot;x];
        fTot=[fTot fx]; % TEST, entropy
    end
end

if exist('signature')
    if signature
        xTot=[xTot;x];
    end
end

end
