function [S1,S2]=subswarm(x,f,i1,i2,dichOption)
% Define two subswarms "around" x(i1,:) and x(i2,:)

[N,~]=size(x);
if i1==i2
  dichOption=1; % In this rare particular  case, just fifty-fifty 
end

switch dichOption
  case 0 % According to distances
S1=[i1]; S2=[i2];

for n=1:N
  if n==i1 || n==i2 continue; end
  d1=dist(x(i1,:),x(n,:));
  d2=dist(x(i2,:),x(n,:));
  
  if d1<d2
    S1=[S1,n];
  else
    S2=[S2,n];   
  end
end
  case 1 % Partial
    coeff=1/2;
   distances=dist(x,x(i1,:));
        %distances=dist(x,x(i2,:));

    [~,ind]=sort(distances);
    N1=round(N*coeff);
    S1=ind(1:N1);
    S2=ind(N1+1:N);

case 2 % Best and worst
coeff=3/4;
[~,Ind]=sort(f);
N1=ceil(N*coeff);
N1=N-1; % TEST
S1=Ind(1:N1);
S2=Ind(N1+1:N);
    
end
end
